/*
 File: la_expr_lexical.h
 Date and Time: Fri Jan 30 18:55:13 2015 
*/
#ifndef __la_expr_lexical_h__
#define __la_expr_lexical_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "yacco2_stbl.h"
  
// monolithic grammar: no thread
extern yacco2::State S1_Cla_expr_lexical;
namespace NS_la_expr_lexical {
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[3];
};
class Cla_expr_lexical: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rstripper_ = 569//start_of_rule_list + 0
    ,rhs1_Rstripper_ = 1
   ,R_Rtoks_ = 570//start_of_rule_list + 2
    ,rhs1_Rtoks_ = 2
    ,rhs2_Rtoks_ = 3
   ,R_Rtok_ = 571//start_of_rule_list + 4
    ,rhs1_Rtok_ = 4
    ,rhs2_Rtok_ = 5
    ,rhs3_Rtok_ = 6
    ,rhs4_Rtok_ = 7
    ,rhs5_Rtok_ = 8
    ,rhs6_Rtok_ = 9
  };
  //no of la sets = 2
  //no of states = 11
  Cla_expr_lexical();
  ~Cla_expr_lexical();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[10];
 };
struct Rstripper;
struct Rtoks;
struct Rtok;
struct Rstripper:public yacco2::CAbs_lr1_sym {
  Rstripper(yacco2::Parser* P);
  void op();
  public:
};

struct Rtoks:public yacco2::CAbs_lr1_sym {
  Rtoks(yacco2::Parser* P);
  public:
};

struct Rtok:public yacco2::CAbs_lr1_sym {
  Rtok(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
};

} // end of namespace

#endif
